<?php
/*************************************************************************
* AquaBase.org Project
* http://www.aquabase.org/
*
* If you find it useful though, feel free to buy me something from my
* wishlist, http://www.amazon.fr/exec/obidos/registry/LYSPZYWIVO1R
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
*
*************************************************************************/

include (".\modules\lib\xmlrpc_inc.php");
//include ("xmlrpc_inc.php");

dl('php_gtk' . (strpos(PHP_OS, 'WIN') >= 0 ? '.dll' : '.so'))
  || die('Cannot load php_gtk module!');

if (strpos(PHP_OS, 'WIN') >= 0)
{
  define(WIN, true);
  define(EOL, "\r\n");
}
else
{
  define(WIN, false);
  define(EOL, "\n");
}

/*
** Some global variables
*/
//$host = 'aquabase.localhost';
$host = 'www.aquabase.org';
$url = '/shop/xmlrpc.php';
$debug = 0;

$shop_list = array();
$shop_selected = array();

$html_ent = array_flip(get_html_translation_table(HTML_ENTITIES));

function unhtmlentities($str)
{
  global $html_ent;
  return strtr($str, $html_ent);
}

function convertEOL($str)
{
  if (WIN)
    return preg_replace("//", "\r\n",
                        preg_replace(array("/\\r\\n/m", "/\\n/m"),
                                     "", $str));
  else
    return preg_replace("/\\r\\n/m", "\n", $str);
}

$yes_no_flag = false;
function askYesNo($question)
{
  $GLOBALS['yes_no_flag'] = false;

  $dialog = & new GtkDialog();
  $dialog->set_modal(true);
  $dialog->set_title('Question');
  $dialog->set_position(GTK_WIN_POS_CENTER);
  $dialog->set_border_width(5);
  $dialog->connect_object('destroy', array('gtk', 'main_quit'));

  $vbox = $dialog->vbox;
  $action_area = $dialog->action_area;

  $info_label = &new GtkLabel($question);
  $vbox->pack_start($info_label);

  $button_yes = & new GtkButton('Oui');
  $button_yes->set_flags(GTK_CAN_DEFAULT);
  $button_yes->connect('clicked', 'clickYesNo', true);
  $button_yes->connect('clicked', 'dialogClose', $dialog);
  $button_yes->connect_object('clicked', array('gtk', 'main_quit'));
  $action_area->pack_start($button_yes, true, true, 0);
  $button_yes->grab_default();

  $button_no = & new GtkButton('Non');
  $button_no->connect('clicked', 'clickYesNo', false);
  $button_no->connect('clicked', 'dialogClose', $dialog);
  $button_no->connect_object('clicked', array('gtk', 'main_quit'));
  $action_area->pack_start($button_no, true, true, 0);

	$dialog->show_all();
	gtk::main();
}

function clickYesNo($button, $yes_no)
{
  $GLOBALS['yes_no_flag'] = $yes_no;
}

$ask_string = false;
function askString($question, $old_value)
{
  $GLOBALS['ask_string'] = false;

  $dialog = & new GtkDialog();
  $dialog->set_modal(true);
  $dialog->set_title('Question');
  $dialog->set_position(GTK_WIN_POS_CENTER);
  $dialog->set_border_width(5);
  $dialog->connect_object('destroy', array('gtk', 'main_quit'));

  $vbox = $dialog->vbox;
  $action_area = $dialog->action_area;

  $info_label = &new GtkLabel($question);
  $vbox->pack_start($info_label);

  $value_entry = &new GtkEntry();
  $value_entry->set_text($old_value);
  $vbox->pack_start($value_entry);

  $button_yes = & new GtkButton('Ok');
  $button_yes->set_flags(GTK_CAN_DEFAULT);
  $button_yes->connect('clicked', 'clickAskString', $value_entry);
  $button_yes->connect('clicked', 'dialogClose', $dialog);
  $button_yes->connect_object('clicked', array('gtk', 'main_quit'));
  $action_area->pack_start($button_yes, true, true, 0);
  $button_yes->grab_default();

  $button_no = & new GtkButton('Annuler');
  $button_no->connect('clicked', 'clickAskString_cancel');
  $button_no->connect('clicked', 'dialogClose', $dialog);
  $button_no->connect_object('clicked', array('gtk', 'main_quit'));
  $action_area->pack_start($button_no, true, true, 0);

	$dialog->show_all();
	gtk::main();
}

function clickAskString($button, $entry)
{
  $GLOBALS['ask_string'] = $entry->get_text();
}

function clickAskString_cancel($button)
{
  $GLOBALS['ask_string'] = false;
}
/*
** Create Interface
*/
$w['main'] = & new GtkWindow();
$w['main']->connect_object('destroy', array('gtk', 'main_quit'));
$w['main']->set_title('AquaGes <-> AquaBase.org v0.95 - 07/09/2002 00:06');
$w['main']->set_position(GTK_WIN_POS_CENTER);
$w['main']->set_default_size(600, 500);
$w['main']->show();

$box = & new GtkVBox(false, 0);
$w['main']->add($box);

//list($pix_p, $pix_m) = Gdk::pixmap_create_from_xpm($w['main']->window, null, 'aquabase.xpm');
list($pix_p, $pix_m) = Gdk::pixmap_create_from_xpm($w['main']->window, null, '.\modules\aquabase.xpm');
$p = & new GtkPixmap($pix_p, $pix_m);
$box->pack_start($p, false, true, 5);

$label = & new GtkLabel('Module pour AquaGes ralis par Ludovic Robinot - http://www.aquabase.org');
$box->pack_start($label, false, true, 5);

$w['book'] = & new GtkNotebook();
//$w['book']->connect('switch_page', 'page_switch');
$w['book']->set_tab_pos(GTK_POS_LEFT);
$box->add($w['book']);

$box->pack_start(new GtkHSeparator(), false, true, 5);

$box2 = & new GtkHBox(false, 5);
$box2->set_border_width(5);
$box->pack_start($box2, false, true, 0);

$button = &new GtkButton('Quitter');
$button->connect_object('clicked', array('gtk', 'main_quit'));
$box2->pack_start($button, true, false, 0);

$child = & new GtkFrame('Magasin');
$child->set_border_width(5);

$vbox = &new GtkVBox(false, 5);
$child->add($vbox);

$scrolled_win = &new GtkScrolledWindow();
$scrolled_win->set_border_width(5);
$scrolled_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
$vbox->pack_start($scrolled_win, true, true, 0);

$titles = array(str_pad('ID#', 6),
                str_pad('Nom', 40),
                str_pad('Ville', 40),
                'Code Postal');
$w['shop_list_clist'] = &new GtkCList(4, $titles);
$w['shop_list_clist']->set_selection_mode(GTK_SELECTION_SINGLE);
$w['shop_list_clist']->connect('click_column', 'clist_click_column');
$scrolled_win->add($w['shop_list_clist']);

function clist_click_column($clist, $column)
{
	if ($column == $clist->sort_column)
	{
		if ($clist->sort_type == GTK_SORT_ASCENDING)
		  $clist->set_sort_type(GTK_SORT_DESCENDING);
		else
			$clist->set_sort_type(GTK_SORT_ASCENDING);
	}
	else
		$clist->set_sort_column($column);
		$clist->sort();
}

$hbox = &new GtkHBox();
$hbox->set_border_width(5);
$hbox->set_homogeneous(true);
$vbox->pack_start($hbox, false, false, 0);

$button = &new GtkButton(' Importer la liste ');
$button->connect('clicked', 'shopListImport');
$hbox->pack_start($button, false, false, 5);

/*
$button_all = & new GtkButton('Selectionner tout');
$button_all->connect('clicked', 'select_all');
$hbox->pack_start($button_all, false, false, 5);

function select_all()
{
  $GLOBALS['w']['shop_list_clist']->select_all();
}

$button_none = & new GtkButton('Deselectionner tout');
$button_none->connect('clicked', 'select_none');
$hbox->pack_start($button_none, false, false, 5);

function select_none()
{
  $GLOBALS['w']['shop_list_clist']->unselect_all();
}
*/

$button = &new GtkButton(' Sauver la selection ');
$button->connect('clicked', 'shopListSave');
$hbox->pack_start($button, false, false, 5);

$label_box = & new GtkHBox(false, 0);
$label = & new GtkLabel('Magasin');
$label_box->pack_start($label, false, true, 0);
$label_box->show_all();

$menu_box = & new GtkHBox(false, 0);
$label = & new GtkLabel('Magasin');
$menu_box->pack_start($label, false, true, 0);
$menu_box->show_all();

$w['book']->append_page_menu($child, $label_box, $menu_box);

$w['sbar'] = & new GtkStatusbar();
$box->pack_start($w['sbar'], false, false, 0);
$w['sbar']->push($w['sbar']->get_context_id('Prt ...'), 'Prt ...');

$w['main']->show_all();
gtk::main();
exit(141174);

function setStatus($message = '')
{
  global $w;

  $w['sbar']->push($w['sbar']->get_context_id($message), $message);
  while (gtk::events_pending()) gtk::main_iteration();
}

function deleteEvent()
{
  return false;
}

function dialogClose($button, $dialog)
{
  $dialog->hide();
}

function showMessage($message, $error = 0)
{
  $dialog = &new GtkDialog;
  $dialog->set_modal(true);
  $dialog->set_title(($error ? 'Erreur' : 'Message'));
  $dialog->set_border_width(0);
  $dialog->set_position(GTK_WIN_POS_CENTER);
  $dialog->connect('delete_event', 'deleteEvent');

  $vbox = $dialog->vbox;
  $action_area = $dialog->action_area;

  $info_label = &new GtkLabel($message);
  $vbox->pack_start($info_label);

  $button = &new GtkButton('Ok');
  $button->set_flags(GTK_CAN_DEFAULT);
  $button->connect('clicked', 'dialogClose', $dialog);

  $action_area->pack_start($button, true, true, 0);
  $button->grab_default();
	$dialog->show_all();
}

function shopListSet()
{
  $clist = & $GLOBALS['w']['shop_list_clist'];

	$clist->freeze();
  $clist->clear();
/*
	$clist->set_selection_mode(GTK_SELECTION_EXTENDED);
	$clist->select_all();
	$selection = $clist->selection;
	while (($row = $clist->selection[0]) !== null)
	{
		$clist->remove($row);
	}
	$clist->set_selection_mode(GTK_SELECTION_SINGLE);
*/

  foreach($GLOBALS['shop_list'] as $a)
  {
    $text[0] = sprintf("%04d", $a['id']);
    $text[1] = unhtmlentities($a['name']);
    $text[2] = unhtmlentities($a['town']);
    $text[3] = unhtmlentities($a['zip']);
		$row = $clist->append($text);
  }
  $clist->thaw();
}

function shopListImport()
{
  setStatus('Importation de la liste des magasins depuis AquaBase.org, patientez ...');

  $fd = @fsockopen($GLOBALS['host'], 80);
  if ($fd == FALSE)
  {
    showMessage("Impossible de se connecter  AquaBase.org.\nVrifiez votre connexion internet.", 1);
    setStatus('Importation de la liste annule ...');
    return;
  }
  fclose($fd);

  // Erase old list
  unset($GLOBALS['shop_list']);

  // Retieve shop list from AquaBase.org
  $func = new xmlrpcmsg('aquabase.org.getShopList');
  $client = new xmlrpc_client($GLOBALS['url'], $GLOBALS['host']);
  $client->setDebug($GLOBALS['debug']);
  $r = $client->send($func);
  if ($r == 0)
  {
    showMessage('XML-RPC call to aquabase.org.getShopList() failed', 1);
    setStatus('Importation annule ...');
    return;
  }
  $v = $r->value();
  if ($r->faultCode())
  {
	  showMessage("Erreur XML-RPC\n" .
                "Code: " . $r->faultCode() . "\n" .
                "Reason: '" . $r->faultString() . "'", 1);
    unset($func);
    unset($client);
    unset($r);
    unset($v);
    setStatus('Importation annule ...');
    return;
  }
  unset($func);
  unset($client);
  unset($r);

  // Store list in global variable
  $GLOBALS['shop_list'] = xmlrpc_decode($v);

  // Display it in widget
  shopListSet();
  setStatus('Importation termine ...');
}

function shopListSave()
{
  global $shop_list, $w;

  if (count($shop_list) == 0)
  {
    showMessage('Importez d\'abord des magasins');
    return;
  }

  if (count($w['shop_list_clist']->selection) == 0)
  {
    showMessage('Slectionnez d\'abord des magasins');
    return;
  }

	$selection = $w['shop_list_clist']->selection;
	foreach($selection as $row)
	{
	  $id = intval($w['shop_list_clist']->get_text($row, 0));

    setStatus("Importation du magasin $id ...");

    // Retieve shop from AquaBase.org
    $func = new xmlrpcmsg('aquabase.org.getShop',
                          array(new xmlrpcval($id)));
    $client = new xmlrpc_client($GLOBALS['url'], $GLOBALS['host']);
    $client->setDebug($GLOBALS['debug']);
    $r = $client->send($func);
    if ($r == 0)
    {
      showMessage('XML-RPC call to aquabase.org.getShop() failed', 1);
      return;
    }
    $v = $r->value();
    if ($r->faultCode())
    {
	    showMessage("Erreur XML-RPC\n" .
                  "Code: " . $r->faultCode() . "\n" .
                  "Reason: '" . $r->faultString() . "'", 1);
      unset($func);
      unset($client);
      unset($r);
      unset($v);
      setStatus("Importation du magasin annule ...");
      return;
    }
    unset($func);
    unset($client);
    unset($r);

    $shop = xmlrpc_decode($v);

    $shopName = unhtmlentities($shop['name']);
    while(preg_match('@[\\/:*?"<>|]@', $shopName) ||
          strlen($shopName) > 50)
    {
      askString("Le nom du magasin contient des caractres non authoriss,\n" .
                '\ / : * ? " < > |' . " ou est plus long que 50 caractres.\nVeuillez choisir un autre nom.",
                $shopName);
      if ($GLOBALS['ask_string'] === false)
      {
        setStatus("Importation du magasin annule ...");
        return;
      }
      $shopName = $GLOBALS['ask_string'];
    }

    $file = './magasins/' . $shopName . '.mag';
    $save = true;
    if (file_exists($file))
    {
      askYesNo('Le magasin "' . $shopName .
               '" existe dj, voulez-vous le remplacer ?');
      $save = $GLOBALS['yes_no_flag'];
    }

    if ($save)
    {
      $fd = @fopen($file, 'wb');
      if ($fd != null)
      {
        fwrite($fd, "\"" . $shopName . "\"" . EOL);
        fwrite($fd, "\"" . unhtmlentities(convertEOL($shop['address'])) . "\"" . EOL);
        fwrite($fd, "\"" . unhtmlentities($shop['zip']) . "\"" . EOL);
        fwrite($fd, "\"" . unhtmlentities($shop['town']) . "\"" . EOL);
        fwrite($fd, "\"" . unhtmlentities($shop['country']) . "\"" . EOL);
        fwrite($fd, "\"" . $shop['phone'] . "\"" . EOL);
        fwrite($fd, "\"" . $shop['fax'] . "\"" . EOL);
        fwrite($fd, "\"" . $shop['email'] . "\"" . EOL);
        fwrite($fd, "\"" . $shop['VPC'] . "\"" . EOL);
        fwrite($fd, "\"" . $shop['url'] . "\"" . EOL);
        fwrite($fd, "\"" . preg_replace('/"/', "''", unhtmlentities(convertEOL($shop['hours']))) . "\"" . EOL);
        fwrite($fd, "\"" . preg_replace('/"/', "''", unhtmlentities(convertEOL($shop['comments']))) . "\"" . EOL);
        fclose($fd);
        setStatus("Importation du magasin $id termine ...");
      }
      else
      {
        showMessage("Cannot open \"$file\ for writing", 1);
        setStatus("Importation du magasin annule ...");
      }
    }
    else
    {
       setStatus("Importation du magasin annule ...");
    }
    unset($shop);

  }
}
?>
